package api

import (
	"sku3dweb/db/model"
	"sku3dweb/db/repo"

	"github.com/gin-gonic/gin"
)

func CreateUserCamerasRouter(router *GinRouter) {

	CreateArrayCRUD(router, "/user/camera", &ArrayCRUDOption{
		Collection:     repo.CollectionUser,
		ArrayFieldPath: "cameras",
		NewModel: func(c *gin.Context) interface{} {
			camera := &model.SceneCamera{}
			c.ShouldBindJSON(camera)
			return camera
		},
		EmtyModel: func(c *gin.Context) interface{} {
			camera := &model.SceneCamera{}
			return camera
		},
		NeedsUpdate:   false,
		NeedsRemove:   true,
		SearchProject: []string{"cameras"},
	})

	router.POSTJWT("/user/camera/update/:id", func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
		id := c.Param("id")
		if len(id) < 1 {
			return nil, NewError("id不能为空!")
		}

		scene := model.SceneCamera{}
		err := c.ShouldBindJSON(&scene)
		if err != nil {
			return nil, err
		}

		optSet := repo.Map{}
		optSet["scenes.$.enable"] = scene.Enable

		option := &repo.ArrayOneUpdateOption{
			CollectName: repo.CollectionUser,
			Id:          id,
			Query:       repo.Map{"cameras.id": scene.Id},
			Set:         optSet,
		}
		return repo.RepoDocArrayOneUpdate(apictx.CreateRepoCtx(), option)
	})
}
