package bus

import (
	"sku3dweb/conf"

	"github.com/nats-io/nats.go"
)

type MeshAssetProcessRequest struct {
	MainCollection string `json:"mainCollection"`
	MainId         string `json:"mainId"`
	MeshId         string `json:"meshId"`
	UserId         string `json:"userId"`
	MeshUrl        string `json:"meshUrl"`
}

type ShadowProcessRequest struct {
	TaskId  string `json:"taskId"`
	UserId  string `json:"userId"`
	MeshUrl string `json:"meshUrl"`
}

type HdrAssetProcessRequest struct {
	DatabaseId string `json:"databaseId"`
	Collection string `json:"collection"`
	AssetId    string `json:"assetId"`
	UserId     string `json:"userId"`
	FileUrl    string `json:"fileUrl"`
}

type RenderWorkerRequest struct {
	TaskId string `json:"taskId"`
	UserId string `json:"userId"`
}

// 单品或场景渲染请求
func SceneRenderReq(taskId, userId string) error {
	natsConf := conf.AppConfig.Nats
	req := &RenderWorkerRequest{TaskId: taskId, UserId: userId}
	return NatsCenter.PushMessage(natsConf.RenderStreamTopic, req, nats.MsgId(taskId))
}
