package model

import "time"

const (
	Feature_Person  = "person-perms"
	Feature_Company = "company-perms"
	Feature_Other   = "home-perms"
)

type FeatureItem struct {
	Value  string `bson:"value,omitempty" json:"value"`
	Name   string `bson:"name,omitempty" json:"name"`
	Enable *bool  `bson:"enable,omitempty" json:"enable"`
}

type Features struct {
	Group    string         `bson:"group,omitempty" json:"group"`
	Enable   *bool          `bson:"enable,omitempty" json:"enable"`
	Children []*FeatureItem `bson:"children,omitempty" json:"children"`
}

type SystemFeatures struct {
	Features []*Features `bson:"features,omitempty" json:"features"`
}

type SystemPersonFeatures struct {
	UpdateTime time.Time       `bson:"updateTime,omitempty" json:"updateTime"`
	Type       string          `bson:"type,omitempty" json:"type"`
	Value      *SystemFeatures `bson:"value,omitempty" json:"value"`
}

type SystemCompanyFeatures struct {
	UpdateTime time.Time       `bson:"updateTime,omitempty" json:"updateTime"`
	Type       string          `bson:"type,omitempty" json:"type"`
	Value      *SystemFeatures `bson:"value,omitempty" json:"value"`
}

type SystemOtherFeatures struct {
	UpdateTime time.Time       `bson:"updateTime,omitempty" json:"updateTime"`
	Type       string          `bson:"type,omitempty" json:"type"`
	Value      *SystemFeatures `bson:"value,omitempty" json:"value"`
}
